#!/bin/bash

function listproducts
{
	for i in target/*
		do
			echo -n "Intel "
			if [ $(echo $i | grep "W_CC") ]
				then echo -n "C++ Compiler for Windows"
				versiontag=$versiontag"CW"
			fi
			if [ $(echo $i | grep "W_FC") ]
				then echo -n "Fortran Compiler for Windows"
				versiontag=$versiontag"FW"
			fi
			if [ $(echo $i | grep "l_cc") ]
				then echo -n "C++ Compiler for Linux"
				versiontag=$versiontag"CL"
			fi
			if [ $(echo $i | grep "l_fc") ]
				then echo -n "Fortran Compiler for Linux"
				versiontag=$versiontag"FL"
			fi
			echo -n ", Version "
			b="$( echo $i | sed s/.*_// | sed s/.exe$// | sed s/.tar.gz$// )"
			versiontag=$versiontag$b"-"
			versionnumbers=$versionnumbers$b", "
			echo $b
		done
	versionnumbers=${versionnumbers%, }
}
CURRENTDIR=`pwd`
echo "OSC Compiler ISO Builder"
echo "=-=-=-=-=-=-=-=-=-=-=-=-"
echo
echo "Building ISO for the following products:"
echo
listproducts
echo
echo -n "Making temporary directory..."
TMPDIR=`mktemp -d -t osciso.XXXXXX` || exit 1
echo "done"
echo -n "Copying files to $TMPDIR....."
cp target/* $TMPDIR
cp -r include $TMPDIR
cp -r template $TMPDIR
echo "done"
echo -n "Unpacking tarballs..."
for i in $TMPDIR/*.tar.gz
	do
		tar -C $TMPDIR -zxf $i
	done
mkdir -p $TMPDIR/buildd
mv $TMPDIR/*/*.rpm $TMPDIR/buildd &> /dev/null
cd $TMPDIR/buildd
for i in *.rpm
	do
		mkdir $i.d
		mv $i $i.d &> /dev/null
		cd $i.d
		rpm2cpio $i | cpio -id &> /dev/null
		mv opt/intel intel
		sed -i -e 's/setenv INTEL_LICENSE_FILE /setenv INTEL_LICENSE_FILE 28518@lic1.osc.ox.ac.uk:/' intel/*/9.0/bin/i*vars.csh &> /dev/null
		sed -i -e 's/INTEL_LICENSE_FILE="/INTEL_LICENSE_FILE="28518@lic1.osc.ox.ac.uk:/' intel/*/9.0/bin/i*vars.sh &> /dev/null
		e=$(echo $i | sed s/rpm/tar.gz/)
		tar czf ../$e intel
		cd ..
		rm -r $i.d
	done
echo "done"
cd ..
echo -n "Building distribution..."
sed -i "s/%VERSIONNUMBERS%/$versionnumbers/" template/README.linux
cp template/* buildd/
cp include/* buildd/
echo "done"
echo -n "Creating ISO file..."
ISONAME=`mktemp -t osccompilers.XXXXXX` || exit 1
mkisofs -r -q -o $ISONAME $TMPDIR/buildd
echo "done"
echo -n "Cleaning up temporary files..."
rm -r $TMPDIR
mv $ISONAME $CURRENTDIR/osc-$versiontag.iso
echo "done"
echo
echo "osc-$versiontag.iso created"
